{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UCosmicExpansionTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UCosmicExpansion;

type

  { TCosmicExpansionFullDataTestCase }

  TCosmicExpansionFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

  { TCosmicExpansionExampleTestCase }

  TCosmicExpansionExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

implementation

{ TCosmicExpansionFullDataTestCase }

function TCosmicExpansionFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TCosmicExpansion.Create;
end;

procedure TCosmicExpansionFullDataTestCase.TestPart1;
begin
  AssertEquals(9686930, FSolver.GetResultPart1);
end;

{ TCosmicExpansionExampleTestCase }

function TCosmicExpansionExampleTestCase.CreateSolver: ISolver;
begin
  Result := TCosmicExpansion.Create;
end;

procedure TCosmicExpansionExampleTestCase.TestPart1;
begin
  AssertEquals(374, FSolver.GetResultPart1);
end;

initialization

  RegisterTest(TCosmicExpansionFullDataTestCase);
  RegisterTest(TCosmicExpansionExampleTestCase);
end.

